﻿SystemOrganization addCategory: #SeasideJ!

!WAUrl methodsFor: '*seasideJ-override' stamp: 'mu 1/31/2008 23:21'!
addToPath: aString
	| str |
	str := aString.
	str isWideString ifTrue: [str := str encodeForHTTP].
	self path addAll: (str findTokens: '/')! !

!WAApplication methodsFor: '*seasideJ-override' stamp: 'mu 1/31/2008 22:45'!
updateRoot: anHtmlRoot

	self updateRootAttributes: anHtmlRoot.

	self libraries do: [:ea | ea default updateRoot: anHtmlRoot]! !

!WAApplication methodsFor: '*seasideJ' stamp: 'mu 7/2/2006 23:02'!
updateRootAttributes: anHtmlRoot

	| lang |
	lang _ self preferenceAt: #lang.
	anHtmlRoot htmlAttributes at: 'xml:lang' put: lang.
	anHtmlRoot htmlAttributes at: 'lang' put: lang.

	! !

!WAGlobalConfiguration methodsFor: '*seasideJ-override' stamp: 'mu 1/31/2008 22:46'!
attributes
	^ Array
		with: ((WAListAttribute key: #serverProtocol group: #server) options: #(http https))
		with: (WAStringAttribute key: #serverHostname group: #server)
		with: (WANumberAttribute key: #serverPort group: #server)
		with: (WAStringAttribute key: #serverPath group: #server)
		with: (WABooleanAttribute key: #deploymentMode)
		with: (WAStringAttribute key: #lang group: #server)! !

!WAGlobalConfiguration methodsFor: '*seasideJ' stamp: 'mu 7/2/2006 22:16'!
lang
	^ 'en'! !

!WideString methodsFor: '*seasideJ' stamp: 'mu 8/1/2005 19:25'!
prettyPrintHtmlOn: aStream indentLevel: aNumber

	aStream nextPutAll: (self convertToHtmlOutput).
! !

!WideString methodsFor: '*seasideJ' stamp: 'mu 8/1/2005 19:26'!
printHtmlOn: aStream

	aStream nextPutAll: (self convertToHtmlOutput).
! !

!String methodsFor: '*seasideJ' stamp: 'mu 8/1/2005 19:28'!
convertFromHtmlInput

	^ self convertFromWithConverter: SeasideSettings innerConverter
! !

!String methodsFor: '*seasideJ' stamp: 'mu 8/1/2005 19:27'!
convertToHtmlOutput

	^ self convertToWithConverter: SeasideSettings outerConverter
! !

!String methodsFor: '*seasideJ-override' stamp: 'ky 7/8/2006 17:56'!
unescapePercentsWithTextEncoding: encodingName 
	"decode string including %XX form"
	| unescaped char asciiVal specialChars oldPos pos converter |
	unescaped := ReadWriteStream on: String new.
	specialChars := '+%' asCharacterSet.
	oldPos := 1.
	[pos := self indexOfAnyOf: specialChars startingAt: oldPos.
	pos > 0]
		whileTrue: [unescaped
				nextPutAll: (self copyFrom: oldPos to: pos - 1).
			char := self at: pos.
			(char = $%
					and: [pos + 2 <= self size])
				ifTrue: [asciiVal := (self at: pos + 1) asUppercase digitValue * 16 + (self at: pos + 2) asUppercase digitValue.
					asciiVal > 255
						ifTrue: [^ self].
					unescaped
						nextPut: (Character value: asciiVal).
					pos := pos + 3.
					pos <= self size
						ifFalse: [char := nil].
					oldPos := pos]
				ifFalse: [char = $+
						ifTrue: [unescaped nextPut: Character space]
						ifFalse: [unescaped nextPut: char].
					oldPos := pos + 1]].
	oldPos <= self size
		ifTrue: [unescaped
				nextPutAll: (self copyFrom: oldPos to: self size)].
	converter := (TextConverter newForEncoding: encodingName)
				ifNil: [TextConverter newForEncoding: nil].
	^ [unescaped contents convertFromWithConverter: converter]
		on: Error
		do: ["the contents may be squeak-encoded"
			unescaped contents]! !

Object subclass: #SeasideSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideJ'!

SeasideSettings class
	instanceVariableNames: 'outerConverter innerConverter'!

SeasideSettings class
	instanceVariableNames: 'outerConverter innerConverter'!

!SeasideSettings class methodsFor: 'accessing' stamp: 'mu 8/1/2005 19:23'!
innerConverter
	innerConverter ifNil: [innerConverter := (Smalltalk at: #UTF8TextConverter ifAbsent:[]) ifNotNilDo: [:c | c new]].
	^innerConverter! !

!SeasideSettings class methodsFor: 'accessing' stamp: 'mu 8/1/2005 19:21'!
innerConverter: aTextConverter
	innerConverter _ aTextConverter! !

!SeasideSettings class methodsFor: 'accessing' stamp: 'mu 8/1/2005 19:24'!
outerConverter
	outerConverter ifNil: [outerConverter := (Smalltalk at: #UTF8TextConverter ifAbsent:[]) ifNotNilDo: [:c | c new]].
	^outerConverter! !

!SeasideSettings class methodsFor: 'accessing' stamp: 'mu 8/1/2005 19:22'!
outerConverter: aTextConverter
	outerConverter := aTextConverter! !

!SeasideSettings class methodsFor: 'accessing' stamp: 'mu 2/9/2007 11:02'!
port
	^(ApplicationService serviceNamed: 'seaside' ifAbsent: [])
		ifNotNilDo: [:ser | ser portNumber].! !

WAKomEncoded subclass: #KomSeasideJ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideJ'!

KomSeasideJ class
	instanceVariableNames: 'isPatched'!

KomSeasideJ class
	instanceVariableNames: 'isPatched'!

!KomSeasideJ class methodsFor: 'private' stamp: 'mu 2/18/2007 22:10'!
guessIsPatched
	"KomSeasideJ guessIsPatched"
	| versionString |
	versionString := SystemVersion current version.

	(('Squeakland 3.8-05*' match: versionString)
			and: [SystemVersion current highestUpdate > 500])
		ifTrue: [^ true].

	('Squeak3.9*' match: versionString) ifTrue: [^true].

	^ false! !

!KomSeasideJ class methodsFor: 'accessing' stamp: 'mu 2/7/2007 22:14'!
port
	self service ifNil: [^nil].
	^self service portNumber! !

!KomSeasideJ class methodsFor: 'accessing' stamp: 'mu 2/7/2007 22:07'!
service
	^service! !

!KomSeasideJ class methodsFor: 'service' stamp: 'mu 2/7/2007 22:13'!
startOn: aPort
	self guessIsPatched ifFalse: [^self error: 'Use older SeasideJ(SeasideJ-mu.19.mcz)'].
	super startOn: aPort.
! !

!KomSeasideJ methodsFor: 'actions' stamp: 'mu 1/31/2008 23:16'!
convertResponse: aResponse
	| komResponse  |
	aResponse ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].

	komResponse :=  HttpResponse new.

	aResponse cookies do:
		[:assoc | komResponse setCookieName: assoc key value: assoc valueWithExpiry path: assoc path].

	self outerHeadersFrom: aResponse headers.
	aResponse headers associationsDo: [:assoc | komResponse fieldAt: assoc key put: assoc value].
	
	komResponse status: (HttpResponse statusSymbolFor: aResponse status).

	" conversion to UTF-8 "
	komResponse contents: (self contentsOfResponse: aResponse).
	komResponse contentType: aResponse contentType.

	^ komResponse! !

!KomSeasideJ methodsFor: 'private-encoding' stamp: 'mu 2/2/2008 16:00'!
outerContentDispositionValueFrom: aString 
	| str wStr former latter done |
	aString isWideString
		ifFalse: [^ aString].
	str := aString readStream.
	wStr := '' writeStream.
	[str atEnd
		or: [str peek = $=]]
		whileFalse: [wStr nextPut: str next].
	former := wStr contents.
	latter := str skip: 1; upToEnd.
	latter first = $" ifTrue: [latter := latter copyFrom: 2 to: (latter size -1)].
	latter := latter encodeForHTTP.
	done := former , ('*=utf-8''{1}''' format: {Locale current isoLanguage}) , latter.
	^done! !

!KomSeasideJ methodsFor: 'private-encoding' stamp: 'mu 7/5/2006 13:07'!
outerHeadersFrom: headers 
	headers ifEmpty: [^ headers].
	headers
		do: [:keyAndValue | 
			| key value | 
			key := keyAndValue key asLowercase.
			value := keyAndValue value.
			(key = 'location') ifTrue: [keyAndValue
						value: (self outerLocationValueFrom: value)].
			(key = 'content-disposition')
				ifTrue: [keyAndValue
						value: (self outerContentDispositionValueFrom: value)]].
	^ headers! !

!KomSeasideJ methodsFor: 'private-encoding' stamp: 'mu 9/5/2005 23:23'!
outerLocationValueFrom: aString
	^self outerValueFrom: aString! !

!KomSeasideJ methodsFor: 'private-encoding' stamp: 'mu 7/2/2006 14:46'!
outerValueFrom: aString
	aString isWideString ifTrue: [^aString encodeForHTTP].
	^aString! !

!KomSeasideJ methodsFor: 'private-decoding' stamp: 'mu 2/2/2008 18:23'!
utf8ToSqueak: aByteString
	^aByteString convertFromWithConverter: UTF8TextConverter  new! !

!WASession methodsFor: '*seasideJ-override' stamp: 'mu 1/10/2006 23:03'!
download: contents mimeType: mimeType filename: fileName
	| fileNamePart |
	
	"Refer: RFC2231"

	fileNamePart := fileName isWideString ifTrue: [('*=utf-8''{1}''' format: {Locale current isoLanguage}) , fileName encodeForHTTP] ifFalse: [ '=' , fileName].

	(((self currentRequest headerAt: 'user-agent') asString findString: 'MSIE') > 0) ifTrue: [
		fileNamePart _ '=', fileName encodeForHTTP. "POOR IE!!!!"
	].

	self respond:
			[:url |
			| response |
			response := WAResponse new.
			response contentType: mimeType.
			response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
			response headerAt: 'content-disposition'
				put: ('attachment ; filename' , fileNamePart).
			response headerAt: 'Content-length' put: contents size printString.
			response contents nextPutAll: contents.
			response]
! !
